/***********************************
 *
 *	Compulab Ltd.
 *
 *	This file contains an API
 *	For the activation of the GPRS
 *	Module
 *
 *
 ***********************************/

#ifndef _GPRS_API_H
#define _GPRS_API_H
#include <winioctl.h>
#define PXAREG_IOCTL_INDEX							0x0850

#define IOCTL_PXAREG_GPRS_ON							CTL_CODE( FILE_DEVICE_UNKNOWN,  \
                                                        PXAREG_IOCTL_INDEX + 2,       \
                                                        METHOD_BUFFERED,                \
                                                        FILE_ANY_ACCESS)

#define IOCTL_PXAREG_GPRS_OFF							CTL_CODE( FILE_DEVICE_UNKNOWN,  \
                                                        PXAREG_IOCTL_INDEX + 3,       \
                                                        METHOD_BUFFERED,                \
                                                        FILE_ANY_ACCESS)




/**************************
 *
 *	Functions for Access
 *
 *************************/
#define PXA_NAME	L"PXA1:"

__inline	BOOL	OpenGPRS()
{
	HANDLE	hDevice = INVALID_HANDLE_VALUE;
	BOOL	bRet = FALSE;

	hDevice = CreateFile(PXA_NAME, 0, 0, NULL, 0, 0, NULL);
	if (hDevice == INVALID_HANDLE_VALUE)
		return FALSE;

	bRet = DeviceIoControl(
        hDevice, IOCTL_PXAREG_GPRS_ON, NULL, 0, NULL, 0, NULL, NULL);

	CloseHandle(hDevice);
	return bRet;
}

__inline	BOOL	CloseGPRS()
{
	HANDLE	hDevice = INVALID_HANDLE_VALUE;
	BOOL	bRet = FALSE;

	hDevice = CreateFile(PXA_NAME, 0, 0, NULL, 0, 0, NULL);
	if (hDevice == INVALID_HANDLE_VALUE)
		return FALSE;

	bRet = DeviceIoControl(
        hDevice, IOCTL_PXAREG_GPRS_OFF, NULL, 0, NULL, 0, NULL, NULL);

	CloseHandle(hDevice);
	return bRet;
}

#endif //_GPRS_API_H
