// RTCResumeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RTCResume.h"
#include "RTCResumeDlg.h"

#include <Windows.h>
#include <Notify.h>

#include "cm_x270.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CRTCResumeDlg dialog
CRTCResumeDlg *pCurDialog= NULL;

CRTCResumeDlg::CRTCResumeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRTCResumeDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_vResumeCnt = 5;
	m_vSuspendCnt = 10;
}

void CRTCResumeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Text(pDX, IDC_EDIT1, m_vSuspendCnt);
	DDV_MinMaxDWord(pDX, m_vSuspendCnt, 0, 3600);
	DDX_Text(pDX, IDC_EDIT2, m_vResumeCnt);
	DDV_MinMaxDWord(pDX, m_vResumeCnt, 0, 3600);
	DDX_Text(pDX, IDC_EDIT3, m_vMemoryInUse);
	DDX_Control(pDX, IDC_CHECK_PERIODIC, b_Periodic);
}

BEGIN_MESSAGE_MAP(CRTCResumeDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_START_BUTTON, &CRTCResumeDlg::OnBnClickedStartButton)
	ON_BN_CLICKED(IDC_STOP_BUTTON, &CRTCResumeDlg::OnBnClickedStopButton)
	ON_WM_TIMER()


	ON_EN_CHANGE(IDC_EDIT1, &CRTCResumeDlg::OnEnChangeEdit1)
	ON_EN_CHANGE(IDC_EDIT2, &CRTCResumeDlg::OnEnChangeEdit2)
END_MESSAGE_MAP()


DWORD CALLBACK TimerThread( IN PVOID context )
{
	MEMORYSTATUS info;

    while(1)
	{
		GlobalMemoryStatus(&info);
		pCurDialog->m_vMemoryInUse = info.dwTotalPhys - info.dwAvailPhys - 1;
		pCurDialog->m_vMemoryInUse /= 1024;
		pCurDialog->Update();
		Sleep(1000);
	}
}
void CRTCResumeDlg::Update()
{
      SendMessage( WM_USER_UPDATE_DATA, FALSE, 0 );
}
// CRTCResumeDlg message handlers
BOOL CRTCResumeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	b_Periodic.SetCheck(TRUE);
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	pCurDialog = (CRTCResumeDlg*)this;

	HANDLE ht;
	ht = CreateThread(NULL, 0, TimerThread, this, 0, NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CRTCResumeDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_RTCRESUME_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_RTCRESUME_DIALOG));
	}
}
#endif


void CRTCResumeDlg::OnBnClickedStartButton()
{
	UpdateData(TRUE);
	m_nTimer = SetTimer(1,m_vSuspendCnt*1000,NULL);
}


void CRTCResumeDlg::OnTimer(UINT nIDEvent) 
{
	DWORD dwWakeTime, dwReturned, dwWakeTimeAccepted;
  
	// TODO: Add your message handler code here and/or call default
	CDialog::OnTimer(nIDEvent);
	if (!b_Periodic.GetCheck())
		if (m_nTimer)
			KillTimer(m_nTimer);

	//Wakeup in m_vResumeCnt seconds 
	dwWakeTime = m_vResumeCnt;
	KernelIoControl( IOCTL_RTC_ALARM_CALL, 
                                  (LPVOID)&dwWakeTime, 
                                  sizeof(DWORD), 
                                  (LPVOID)&dwWakeTimeAccepted, 
                                  sizeof(DWORD), 
                                  &dwReturned);


	//Emulate Suspend by pressing Suspend button.
	::keybd_event(VK_OFF, 0, 0, 0); 
	::keybd_event(VK_OFF, 0, KEYEVENTF_KEYUP, 0);
}

void CRTCResumeDlg::OnBnClickedStopButton()
{
	if (m_nTimer)
			KillTimer(m_nTimer);
}


LRESULT CRTCResumeDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	// TODO: Add your specialized code here and/or call the base class

	 if( message == WM_USER_UPDATE_DATA ) {
            if( wParam )
                  UpdateData( TRUE );
            else
                  UpdateData( FALSE );
      }

	return CDialog::WindowProc(message, wParam, lParam);
}

void CRTCResumeDlg::OnEnChangeEdit1()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	UpdateData( TRUE );
}

void CRTCResumeDlg::OnEnChangeEdit2()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	UpdateData( TRUE );
}
